SystemOrganization addCategory: #'EjerciciosPoo-TusLibros'!

Exception subclass: #CanNotAddABookFromOtherEditorialToACart
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

Object subclass: #Book
	instanceVariableNames: 'editorial isbn price'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!Book class methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/8/2012 17:38'!
newWithEditorial: anEditorial isbn: anIsbn price: aPrice

	^Book new initializeWithEditorial: anEditorial isbn: anIsbn price: aPrice! !

!Book methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/8/2012 17:40'!
initializeWithEditorial: anEditorial isbn: anIsbn price: aPrice

	editorial := anEditorial.
	isbn := anIsbn.
	price := aPrice.! !

Bag subclass: #Cart
	instanceVariableNames: 'editorial'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!Cart class methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/8/2012 17:09'!
newWithEditorial: anEditorial
	
	^self new initializeWithEditorial: anEditorial! !

!Cart methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/8/2012 17:09'!
initializeWithEditorial: anEditorial

	editorial := anEditorial! !

TestCase subclass: #TusLibrosTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!TusLibrosTest methodsFor: 'books' stamp: 'IgalFrid 6/8/2012 17:37'!
bookFromEditorial1 

	^Book newWithEditorial: 1 isbn:'Libro1' price: 3! !

!TusLibrosTest methodsFor: 'books' stamp: 'IgalFrid 6/8/2012 17:41'!
bookFromEditorial2 

	^Book newWithEditorial: 2 isbn:'Libro2' price: 3! !

!TusLibrosTest methodsFor: 'errors' stamp: 'IgalFrid 6/8/2012 17:45'!
canNotAddABookFromOtherEditorialToACart
	
	^CanNotAddABookFromOtherEditorialToACart! !

!TusLibrosTest methodsFor: 'carts' stamp: 'IgalFrid 6/8/2012 17:07'!
cartFromEditorial1 
	
	^Cart newWithEditorial: 1.! !

!TusLibrosTest methodsFor: 'carts' stamp: 'IgalFrid 6/8/2012 17:07'!
cartFromEditorial2 
	
	^Cart newWithEditorial: 2.! !

!TusLibrosTest methodsFor: '1 - Test cart' stamp: 'IgalFrid 6/8/2012 17:07'!
test01NewCartShouldBeEmpty

	self assert: self cartFromEditorial1 isEmpty! !

!TusLibrosTest methodsFor: '1 - Test cart' stamp: 'IgalFrid 6/8/2012 17:02'!
test02CanAddABookFromTheSameEditorialOfTheCart

	| cart |
	
	cart := self cartFromEditorial1.
	cart add: self bookFromEditorial1.
	self deny: cart isEmpty! !

!TusLibrosTest methodsFor: '1 - Test cart' stamp: 'IgalFrid 6/8/2012 17:44'!
test03CannotAddABookFromOtherEditorialToACart

	| cart |
	
	cart := self cartFromEditorial1.
	self should: [ self cartFromEditorial1 add: self bookFromEditorial2] raise: self canNotAddABookFromOtherEditorialToACart.! !
